using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp2
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int q = int.Parse(s[1]);
            long[] dani = new long[n];
            long[] plazme = new long[n];
            for (int i = 0; i < n; i++)
            {
                s = Console.ReadLine().Split();
                dani[i] = long.Parse(s[0]);
                plazme[i] = long.Parse(s[1]);
            }
            int indeks = 0;
            long pojedeneplazme = 0;
            long pojeden = 0;
            long zadnjidan = 0;

            for (int i = 0; i < q; i++)
            {
                long upiti = long.Parse(Console.ReadLine());
                while (indeks < n && dani[indeks] <= upiti)
                {
                    long danj = dani[indeks] - zadnjidan;
                    if (pojeden >= danj)
                    {
                        pojeden -= danj;
                        pojedeneplazme += danj;
                    }
                    else
                    {
                        pojedeneplazme += pojeden;
                        pojeden = 0;
                    }
                    pojeden += plazme[indeks];
                    pojedeneplazme++;
                    pojeden--;

                    zadnjidan = dani[indeks];
                    indeks++;
                }
                long preostalidani = upiti - zadnjidan;
                if (pojeden >= preostalidani)
                {
                    pojedeneplazme += preostalidani;
                    pojeden -= preostalidani;
                }
                else
                {
                    pojedeneplazme += pojeden;
                    pojeden = 0;
                }
                Console.WriteLine(pojedeneplazme);
            }
            Console.ReadLine();

        }
    }
}